﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace CSV2SHP
{
    class FieldInfo
    {
        private String FieldName = null;
        private bool bExport = true;
        private bool bHorizontalCoord = false;
        private bool bVerticalCoord = false;
        private XrMapLib.XrFieldTypeEnum fieldType = XrMapLib.XrFieldTypeEnum.XrString;
        private ArrayList fieldInfoList = null;

        public FieldInfo(String FieldName, ArrayList fieldInfoList)
        {
            this.FieldName = FieldName;
            this.fieldInfoList = fieldInfoList;
            fieldInfoList.Add(this);
        }

        public String GetFieldName()
        {
            return FieldName;
        }

        public void SetExport(bool bValue)
        {
            bExport = bValue;
            if (!bExport)
            {
                SetHorizontalCoord(false);
                SetVerticalCoord(false);
            }
        }

        public bool GetExport()
        {
            return bExport;
        }

        public void SetHorizontalCoord(bool bValue)
        {
            if (bValue)
            {
                bExport = true;

                int cntFields = fieldInfoList.Count;
                for (int iField = 0; iField < cntFields; ++iField)
                {
                    FieldInfo fi = fieldInfoList[iField] as FieldInfo;
                    fi.SetHorizontalCoord(false);
                }
            }

            bHorizontalCoord = bValue;
        }

        public bool GetHorizontalCoord()
        {
            return bHorizontalCoord;
        }

        public void SetVerticalCoord(bool bValue)
        {
            if (bValue)
            {
                bExport = true;

                int cntFields = fieldInfoList.Count;
                for (int iField = 0; iField < cntFields; ++iField)
                {
                    FieldInfo fi = fieldInfoList[iField] as FieldInfo;
                    fi.SetVerticalCoord(false);
                }
            }

            bVerticalCoord = bValue;
        }

        public bool GetVerticalCoord()
        {
            return bVerticalCoord;
        }

        public void SetFieldType(XrMapLib.XrFieldTypeEnum type)
        {
            fieldType = type;
        }

        public XrMapLib.XrFieldTypeEnum GetFieldType()
        {
            return fieldType;
        }
    }
}
